#!/bin/bash

retval=0

installLogFile=/var/log/PMC-Sierra_maxRAID.log

if [ -f /etc/redhat-release ] ; then
        v1=`cat /etc/redhat-release | cut -f1 -d " "`
        v2=`cat /etc/redhat-release | cut -f2 -d " "`
        Linux=$v1$v2
else
        if [ -f /etc/SuSE-release ] ; then
                Linux=`cat /etc/SuSE-release | grep SUSE | cut -f1 -d " "`
        fi
fi

if [ "$1" == "-c" ] ;
then
#Configure the product
	if [ "$2" == "" ] ; then
        	echo "Installation path is not specified. Cannot configure"
	        echo "Installation path is not specified. Cannot configure" >> $installLogFile
		exit
	else
	        _installedPath=$2
		installedPath=$_installedPath"/PMC-Sierra/maxRAID"
	fi
	echo Configuring...
	if [ -d /etc/PMC-Sierra ] ; then
        	rm -rf /etc/PMC-Sierra
	fi
	echo Creating /etc/PMC-Sierra directory >> $installLogFile
	mkdir /etc/PMC-Sierra
	echo Copying maxRAID.conf into /etc/PMC-Sierra >> $installLogFile
	cp scripts/maxRAID.conf /etc/PMC-Sierra
	echo [InstalledPath] >> /etc/PMC-Sierra/maxRAID.conf
	echo $_installedPath >> /etc/PMC-Sierra/maxRAID.conf
	

	#Delete the "AvailableComponents" list from the installed maxRAID.conf file
	echo Delete the AvailableComponents list from the installed maxRAID.conf file >> $installLogFile
	found=0
	newStr=""
	oldStr=""
	for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
	do
		if [ "$oldStr" == "[AvailableComponents]" ] ; then
			found=1
			break
		else
			oldStr=$newStr
		fi
	done
	if [ $found -eq 1 ] ; then
		sed '/AvailableComponents/d' </etc/PMC-Sierra/maxRAID.conf >/etc/PMC-Sierra/maxRAID.conf.new
		rm -rf /etc/PMC-Sierra/maxRAID.conf
		mv /etc/PMC-Sierra/maxRAID.conf.new /etc/PMC-Sierra/maxRAID.conf

		sed '/'$newStr'/d' </etc/PMC-Sierra/maxRAID.conf >/etc/PMC-Sierra/maxRAID.conf.new
		rm -rf /etc/PMC-Sierra/maxRAID.conf
		mv /etc/PMC-Sierra/maxRAID.conf.new /etc/PMC-Sierra/maxRAID.conf
	fi


	#Delete the "SupportedOSLevel" list from the installed maxRAID.conf file
        echo Delete the SupportedOSLevel list from the installed maxRAID.conf file >> $installLogFile
	_found=0
        _newStr=""
        _oldStr=""
        for _newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
        do
                if [ "$_oldStr" == "[SupportedOSLevel]" ] ; then
                        _found=1
                        break
                else
                        _oldStr=$_newStr
                fi
        done
        if [ $_found -eq 1 ] ; then
                sed '/SupportedOSLevel/d' </etc/PMC-Sierra/maxRAID.conf >/etc/PMC-Sierra/maxRAID.conf.new
                rm -rf /etc/PMC-Sierra/maxRAID.conf
                mv /etc/PMC-Sierra/maxRAID.conf.new /etc/PMC-Sierra/maxRAID.conf

                sed '/'$_newStr'/d' </etc/PMC-Sierra/maxRAID.conf >/etc/PMC-Sierra/maxRAID.conf.new
                rm -rf /etc/PMC-Sierra/maxRAID.conf
                mv /etc/PMC-Sierra/maxRAID.conf.new /etc/PMC-Sierra/maxRAID.conf
        fi


	#Check if maxRAID entry is present in /etc/profile
	if [ -e /etc/profile ] ; then
		while read line ;
		do
		    retval=`echo $line | grep maxRAID | wc -l`
		    if [ $retval -gt 0 ] ;
		    then
			break
		    fi
		done < /etc/profile
	fi
#
	if [ $retval -eq 0 ] ; 	then
	    echo Writing maxRAID to /etc/profile >> $installLogFile
	    echo Writing maxRAID to /etc/profile
	    export maxRAID=$installedPath
	    echo export maxRAID=$installedPath"/" >> /etc/profile
	else
	    if [ `env | grep maxRAID | wc -l` -eq 0 ] ;
	    then
		export maxRAID=$installedPath
	    fi
	fi


	#Check if Extended Manageability components are installed
        echo Checking if Extended Manageability components are installed >> $installLogFile
        sh scripts/Verify.sh -c Extended_Manageability
	if [ $? -eq 1 ] ; then

		if [ -e $installedPath/bin/MailerPlugIn.tar.gz ] ; then
			tar -xvf $installedPath/bin/MailerPlugIn.tar.gz -C $installedPath/bin/
			rm -f $installedPath/bin/MailerPlugIn.tar.gz
		fi
		#Adding AENDaemon environment variables at the begining of the startup script
                echo Adding AENDaemon environment variables to startup script >> $installLogFile
		if [ -e /tmp/pmc_maxRAID_Notifier ] ; then
                        rm -f /tmp/maxRAID_Notifier
                fi
                echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_Notifier
		echo export LD_LIBRARY_PATH=$installedPath/Web_Server/JRE/jre1.6.0_12/lib/i386/server >> /tmp/pmc_maxRAID_Notifier
                cat $installedPath/bin/maxRAID_Notifier >> /tmp/pmc_maxRAID_Notifier
                rm -f $installedPath/bin/maxRAID_Notifier
                if [ -e /etc/init.d/maxRAID_Notifier ] ; then
                        rm -f /etc/init.d/maxRAID_Notifier
                fi
                cp /tmp/pmc_maxRAID_Notifier /etc/init.d/
                mv /etc/init.d/pmc_maxRAID_Notifier /etc/init.d/maxRAID_Notifier
                chmod +x /etc/init.d/maxRAID_Notifier
		chkconfig --add maxRAID_Notifier
		chkconfig --level 23456 maxRAID_Notifier on
	        rm -f /tmp/pmc_maxRAID_Notifier


                #Adding Pegasus environment variables at the begining of the startup script
	 	echo Adding Pegasus environment variables to the startup script >> $installLogFile	
                if [ -e /tmp/pmc_maxRAID_CIMServer ] ; then
                        rm -f /tmp/pmc_maxRAID_CIMServer
                fi
                echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_CIMServer
                echo export PEGASUS_HOME=$installedPath"/CIM_Server" >> /tmp/pmc_maxRAID_CIMServer
                echo export PEGASUS_ROOT=$installedPath"/CIM_Server" >> /tmp/pmc_maxRAID_CIMServer
		echo export LD_LIBRARY_PATH=$installedPath"/CIM_Server/lib" >> /tmp/pmc_maxRAID_CIMServer
                cat $installedPath/CIM_Server/bin/maxRAID_CIMServer >> /tmp/pmc_maxRAID_CIMServer
                rm -f $installedPath/CIM_Server/bin/maxRAID_CIMServer
                if [ -e /etc/init.d/maxRAID_CIMServer ] ; then
                        rm -f /etc/init.d/maxRAID_CIMServer
                fi
                cp $installedPath/CIM_Server/rpm/wbem /etc/pam.d/
		cp /tmp/pmc_maxRAID_CIMServer /etc/init.d/
                mv /etc/init.d/pmc_maxRAID_CIMServer /etc/init.d/maxRAID_CIMServer
                chmod +x /etc/init.d/maxRAID_CIMServer
		chkconfig --add maxRAID_CIMServer
		chkconfig --level 23456 maxRAID_CIMServer on
		rm -f /tmp/pmc_maxRAID_CIMServer
		
		#Creating the symbolic links for the cimserver shared libraries
		sh $installedPath/CIM_Server/lib/makeLink.sh $installedPath/CIM_Server/lib
	
		#Adding Tomcat environment variables at the begining of the startup script
		echo Adding Tomcat environment variables to startup script >> $installLogFile
		if [ -e /tmp/pmc_maxRAID_WebServer ] ; then
			rm -f /tmp/pmc_maxRAID_WebServer
		fi
		echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_WebServer
		echo export JRE_HOME=$installedPath"/Web_Server/JRE/jre1.6.0_12/" >> /tmp/pmc_maxRAID_WebServer
		echo export CATALINA_PID=$installedPath"/Web_Server/TOMCAT/bin/PID" >> /tmp/pmc_maxRAID_WebServer
		cat $installedPath/Web_Server/TOMCAT/bin/maxRAID_WebServer >> /tmp/pmc_maxRAID_WebServer
		rm -f $installedPath/Web_Server/TOMCAT/bin/maxRAID_WebServer
                if [ -e /etc/init.d/maxRAID_WebServer ] ; then
                        rm -f /etc/init.d/maxRAID_WebServer
                fi
		cp /tmp/pmc_maxRAID_WebServer /etc/init.d/
		mv /etc/init.d/pmc_maxRAID_WebServer /etc/init.d/maxRAID_WebServer
		chmod +x /etc/init.d/maxRAID_WebServer
		chkconfig --add maxRAID_WebServer
		chkconfig --level 23456 maxRAID_WebServer on
		rm -f /tmp/pmc_maxRAID_WebServer
		
		#Changing the startup sequences of services
		echo Changing the startup sequences of services >> $installLogFile
		if [ "$Linux" == "SUSE" ] ; then
                        rm -rf /etc/init.d/rc2.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc3.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc4.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc5.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc6.d/S01maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc2.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc3.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc4.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc5.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc6.d/S02maxRAID_CIMServer
			
			rm -rf /etc/init.d/rc2.d/S01maxRAID_WebServer
        	        rm -rf /etc/init.d/rc3.d/S01maxRAID_WebServer
                	rm -rf /etc/init.d/rc4.d/S01maxRAID_WebServer
      	        	rm -rf /etc/init.d/rc5.d/S01maxRAID_WebServer
			rm -rf /etc/init.d/rc6.d/S01maxRAID_WebServer
        	        ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc2.d/S03maxRAID_WebServer
                	ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc3.d/S03maxRAID_WebServer
                	ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc4.d/S03maxRAID_WebServer
	                ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc5.d/S03maxRAID_WebServer
			ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc6.d/S03maxRAID_WebServer
		fi
		
		rm -f /tmp/pmc_maxRAID_WebServer
		
		#Adding firewall entry
		echo Adding exception to firewall >> $installLogFile
		if [ "$Linux" == "SUSE" ] ; then
			echo " " >> /etc/PMC-Sierra/maxRAID.conf
			cat /tmp/pmc_custom_ports >> /etc/PMC-Sierra/maxRAID.conf 2> /dev/null 
			rm -rf /tmp/pmc_custom_ports
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
			config_file=/etc/sysconfig/SuSEfirewall2
			tmpfile=/tmp/__firewall_config_$$
			cat $config_file | sed "/^FW_SERVICES_EXT_TCP=/s/\"$/ $WebServer_Port\"/" > $tmpfile
			mv -f $tmpfile $config_file
			rm -rf $tmpfile
			cat $config_file | sed '/^FW_SERVICES_EXT_UDP=/s/\"$/ 427\"/' > $tmpfile
			mv -f $tmpfile $config_file
			rm -rf $tmpfile	
		elif [ "$Linux" == "RedHat" ] ; then
			echo " " >> /etc/PMC-Sierra/maxRAID.conf
			cat /tmp/pmc_custom_ports >> /etc/PMC-Sierra/maxRAID.conf 2> /dev/null
                        rm -rf /tmp/pmc_custom_ports 
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
			echo "--port=$WebServer_Port:tcp" >> /etc/sysconfig/system-config-securitylevel
			echo "--port=427:udp" >> /etc/sysconfig/system-config-securitylevel
		fi
		
		#Adding custom port entries to files
		echo Adding custom port entries to corresponding files >> $installLogFile
		httpPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep CIMServer_httpPort | cut -f2 -d "="`
		echo "httpPort=$httpPort" >> $installedPath/CIM_Server/cimserver_planned.conf	
		
		httpsPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep CIMServer_httpsPort | cut -f2 -d "="`
		echo "httpsPort=$httpsPort" >> $installedPath/CIM_Server/cimserver_planned.conf
	 	sed "s/5988/$httpPort/g" $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml > /tmp/config
		cat /tmp/config > $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml	
		rm -rf /tmp/config
		
		WebServerPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
        	sed "s/8443/$WebServerPort/g" $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml > /tmp/config
		cat /tmp/config > $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml
		rm -rf /tmp/config
		sed "s/8443/$WebServerPort/g" $installedPath/Web_Server/TOMCAT/conf/server.xml > /tmp/config
		cat /tmp/config > $installedPath/Web_Server/TOMCAT/conf/server.xml
		rm -rf /tmp/config
		#rm -rf /tmp/pmc_custom_ports
		
		keytool=$installedPath/Web_Server/JRE/jre1.6.0_12/bin/keytool
                HOSTNAME=`hostname`
                IPADDRESS=`hostname -i`
                HOSTIPSTR="CN=localhost, CN=127.0.0.1,"
                
		if [ "$HOSTNAME" != "" ];then
                        HOSTIPSTR="CN=$HOSTNAME, $HOSTIPSTR"
                fi
                if [ "$IPADDRESS" != "" ];then
                        HOSTIPSTR="$HOSTIPSTR CN=$IPADDRESS,"
                fi

                $keytool -genkey -alias maxRAIDCert -dname "$HOSTIPSTR OU=Enterprise Storage Division, O=PMC-Sierra\, Inc, L=Santa Clara, S=CA, C=USA" -validity 3650 -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123

                $keytool -selfcert -alias maxRAIDCert -validity 3650 -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123

                $keytool -exportcert -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123 -alias maxRAIDCert -file $installedPath/Web_Server/TOMCAT/conf/maxRAIDManager.cer

		
		echo Starting AenDaemon >> $installLogFile
		echo Starting AenDaemon...
		service maxRAID_Notifier start
		
		echo Starting cimserver >> $installLogFile
		echo Starting cimserver...
		service maxRAID_CIMServer start

		echo Starting TOMCAT web server >> $installLogFile
		echo Starting TOMCAT web server...
		service maxRAID_WebServer start
		
	fi

	#Check if CLI is installed
        echo Checking if CLI is installed >> $installLogFile
        sh scripts/Verify.sh -c CLI
        retval=$?
        if [ $retval -eq 1 ] ; then
                cp $installedPath/bin/brcli /usr/bin
        fi


elif [ "$1" == "-u" ]
then
	#Unconfigure
	if [ ! -e /etc/PMC-Sierra/maxRAID.conf ] ; then
		echo Product configuartion file does not exist. Cannot uninstall
		echo Product configuartion file does not exist...Cannot uninstall >> $installLogFile
		exit 255
	else

	#Get the installed path
		newStr=""
		oldStr=""
		for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
		do
			if [ "$oldStr" == "[InstalledPath]" ] ; then
				installedPath=$newStr
				break
			else
				oldStr=$newStr
			fi
		done
	fi
	installedPath=$installedPath"/PMC-Sierra/maxRAID"
	echo Unconfiguring...
	if [ "$2" == "--quiet" ] ; then
		echo Deleting log files >> $installLogFile
		echo Deleting log files...
		rm -rf $installedPath/log/*.log
	else
		echo -n "Would you like to preserve the configuration files: Y(es) / N(o):"
		read insLog
		if [ "$insLog" == "Y" ] || [ "$insLog" == "y" ] ; then
			if [ -e $installedPath/conf/PmcConfAenDaemon.txt ] ; then
				mv -f $installedPath/conf/PmcConfAenDaemon.txt $installedPath/conf/PmcConfAenDaemon.txt.bak
			fi
			if [ -e $installedPath/conf/PlugInConfig.txt ] ; then
				mv -f $installedPath/conf/PlugInConfig.txt $installedPath/conf/PlugInConfig.txt.bak
			fi
			if [ -e $installedPath/conf/PmcConfBrcli.txt ] ; then
				mv -f $installedPath/conf/PmcConfBrcli.txt $installedPath/conf/PmcConfBrcli.txt.bak
			fi
                        if [ -e $installedPath/conf/PmcConfSMIS.txt ] ; then
                        	mv -f $installedPath/conf/PmcConfSMIS.txt $installedPath/conf/PmcConfSMIS.txt.bak
			fi
			if [ -e $installedPath/conf/PmcConfGUI.properties ] ; then
                                mv -f $installedPath/conf/PmcConfGUI.properties $installedPath/conf/PmcConfGUI.properties.bak
                        fi
		fi
		echo -n "Would you like to preserve the components log files: Y(es) / N(o):"
		read insLog
		if [ "$insLog" != "Y" ] && [ "$insLog" != "y" ] ; then
			echo Deleting log files >> $installLogFile
			echo Deleting log files...
			rm -rf $installedPath/log/*.log
		fi
	fi

	#Check if Extended Manageability components are installed
	echo Checking if Extended Manageability component is installed >> $installLogFile
	sh scripts/Verify.sh -c Extended_Manageability
	retval=$?
	if [ $retval -eq 1 ] ; then

		rm -f $installedPath/bin/MailerPlugIn.so
		
		#Deleting firewall settings
		echo Deleting firewall exception entry >> $installLogFile
		if [ "$Linux" == "SUSE" ] ; then
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
                        if [ "$WebServer_Port" == "" ] ; then
                                WebServer_Port=8443
                        fi
			config_file=/etc/sysconfig/SuSEfirewall2
	                tmpfile=/tmp/__firewall_config_$$
			cat $config_file | sed "/^FW_SERVICES_EXT_TCP=/s/ $WebServer_Port//g" > $tmpfile
			mv -f $tmpfile $config_file
			rm -rf $tmpfile
			cat $config_file | sed '/^FW_SERVICES_EXT_UDP=/s/ 427//g' > $tmpfile	
			mv -f $tmpfile $config_file
	                rm -rf $tmpfile
			rm -rf /tmp/pmc_custom_ports
		elif [ "$Linux" == "RedHat" ] ; then
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
			cat /etc/sysconfig/system-config-securitylevel | sed "/^--port=$WebServer_Port:tcp/s/--port=$WebServer_Port:tcp//g" > /tmp/system-config-securitylevel
			mv /tmp/system-config-securitylevel /etc/sysconfig/system-config-securitylevel
			rm -rf /tmp/system-config-securitylevel
			cat /etc/sysconfig/system-config-securitylevel | sed '/^--port=427:udp/s/--port=427:udp//g'> /tmp/system-config-securitylevel
			mv /tmp/system-config-securitylevel /etc/sysconfig/system-config-securitylevel
                        rm -rf /tmp/system-config-securitylevel
		fi

		if [ "`ls /etc/init.d | grep tomcatd`" != "" ];then
                	pid_of_java=`ps -aef | grep maxRAID/Web_Server/TOMCAT | grep -v grep | awk '{print $2}'`
                        kill -9 $pid_of_java
			chkconfig --del tomcatd
                        rm -rf /etc/init.d/tomcatd
			rm -rf $installedPath/Web_Server/TOMCAT/webapps/help
			rm -rf $installedPath/Web_Server/TOMCAT/work/Catalina
                elif [ "`ls /etc/init.d | grep maxRAID_WebServer`" != "" ];then
			echo Stopping TOMCAT web server >> $installLogFile
                	echo Stopping TOMCAT web server...
			service maxRAID_WebServer stop
			chkconfig --del maxRAID_WebServer
			rm -f /etc/init.d/maxRAID_WebServer
		fi
                rm -f $installedPath/Web_Server/TOMCAT/bin/PID
                rm -f $installedPath/Web_Server/TOMCAT/logs/*
		rm -rf $installedPath/Web_Server/TOMCAT/work/*
                rm -f $installedPath/Web_Server/*.log
		rm -rf $installedPath/Web_Server/TOMCAT/webapps/help
		rm -rf $installedPath/conf/PmcConfGUI.properties
                
		if [ "`ls /etc/init.d | grep cimserverd`" != "" ];then
                	service cimserverd stop
                        chkconfig --del cimserverd
                        rm -rf /etc/init.d/cimserverd
		elif [ "`ls /etc/init.d | grep maxRAID_CIMServer`" != "" ];then
			echo Stopping CIM Server >> $installLogFile
                	echo Stopping CIM Server...
			service maxRAID_CIMServer stop
			chkconfig --del maxRAID_CIMServer
			rm -f /etc/init.d/maxRAID_CIMServer
		fi
		rm -rf /etc/pam.d/wbem
		rm -f $installedPath/CIM_Server/lib/*.so

		if [ "`ls /etc/init.d | grep aend`" != "" ];then
                	service aend stop
                        chkconfig --del aend
                        rm -rf /etc/init.d/aend
		elif [ "`ls /etc/init.d | grep maxRAID_Notifier`" != "" ];then
                	echo Stopping AenDaemon >> $installLogFile
                	service maxRAID_Notifier stop
			chkconfig --del maxRAID_Notifier
			rm -f /etc/init.d/maxRAID_Notifier
		fi
	fi

        sed '/maxRAID/d' </etc/profile >/etc/newprofile
       	rm -f /etc/profile
        mv /etc/newprofile /etc/profile

	echo Resetting environment...
	unset maxRAID

        if [ -e /usr/bin/brcli ] ; then
                rm -f /usr/bin/brcli
        fi

elif [ "$1" == "-cc" ]
then
#Configure individual component
	echo Configuring individual component >> $installLogFile
	case $2 in
	"CLI")
	installedPath=$3"/PMC-Sierra/maxRAID"
	echo Checking if CLI is installed >> $installLogFile
	sh scripts/Verify.sh -c CLI
	retval=$?
	if [ $retval -eq 1 ] ; then
		echo Copying brcli in /usr/bin >> $installLogFile
		cp $installedPath/bin/brcli /usr/bin
	fi
	;;
	"Extended_Manageability")
	installedPath=$3"/PMC-Sierra/maxRAID"
	echo Checking if Extended Manageability components are installed >> $installLogFile
        sh scripts/Verify.sh -c Extended_Manageability
	retval=$?
        if [ $retval -eq 1 ] ; then

                if [ -e $installedPath/bin/MailerPlugIn.tar.gz ] ; then
                        tar -xvf $installedPath/bin/MailerPlugIn.tar.gz -C $installedPath/bin/
                        rm -f $installedPath/bin/MailerPlugIn.tar.gz
                fi

                #Adding AENDaemon environment variables at the begining of the startup script
                echo Adding AENDaemon environment variables to startup script >> $installLogFile
		if [ -e /tmp/pmc_maxRAID_Notifier ] ; then
                        rm -f /tmp/maxRAID_Notifier
                fi
                echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_Notifier
		echo export LD_LIBRARY_PATH=$installedPath/Web_Server/JRE/jre1.6.0_12/lib/i386/server >> /tmp/pmc_maxRAID_Notifier
                cat $installedPath/bin/maxRAID_Notifier >> /tmp/pmc_maxRAID_Notifier
                rm -f $installedPath/bin/maxRAID_Notifier
                if [ -e /etc/init.d/maxRAID_Notifier ] ; then
                        rm -f /etc/init.d/maxRAID_Notifier
                fi
                cp /tmp/pmc_maxRAID_Notifier /etc/init.d/
                mv /etc/init.d/pmc_maxRAID_Notifier /etc/init.d/maxRAID_Notifier
                chmod +x /etc/init.d/maxRAID_Notifier
		chkconfig --add maxRAID_Notifier
		chkconfig --level 23456 maxRAID_Notifier on
                rm -f /tmp/pmc_maxRAID_Notifier


                #Adding Pegasus environment variables at the begining of the startup script
                echo Adding Pegasus environment variables to startup script >> $installLogFile
		if [ -e /tmp/pmc_maxRAID_CIMServer ] ; then
                        rm -f /tmp/pmc_maxRAID_CIMServer
                fi
                echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_CIMServer
                echo export PEGASUS_HOME=$installedPath"/CIM_Server" >> /tmp/pmc_maxRAID_CIMServer
                echo export PEGASUS_ROOT=$installedPath"/CIM_Server" >> /tmp/pmc_maxRAID_CIMServer
                echo export LD_LIBRARY_PATH=$installedPath"/CIM_Server/lib" >> /tmp/pmc_maxRAID_CIMServer
                cat $installedPath/CIM_Server/bin/maxRAID_CIMServer >> /tmp/pmc_maxRAID_CIMServer
                rm -f $installedPath/CIM_Server/bin/maxRAID_CIMServer
                if [ -e /etc/init.d/maxRAID_CIMServer ] ; then
                        rm -f /etc/init.d/maxRAID_CIMServer
                fi
		cp $installedPath/CIM_Server/rpm/wbem /etc/pam.d/
                cp /tmp/pmc_maxRAID_CIMServer /etc/init.d/
                mv /etc/init.d/pmc_maxRAID_CIMServer /etc/init.d/maxRAID_CIMServer
                chmod +x /etc/init.d/maxRAID_CIMServer
		chkconfig --add maxRAID_CIMServer
		chkconfig --level 23456 maxRAID_CIMServer on
                
		rm -f /tmp/pmc_maxRAID_CIMServer

		#Creating the symbolic links for the shared libraries
                echo Creating the symbolic links for the shared libraries >> $installLogFile
		sh $installedPath/CIM_Server/lib/makeLink.sh $installedPath/CIM_Server/lib

		#Adding Tomcat environment variables at the begining of the startup script
                echo Adding Tomcat environment variables to the startup script >> $installLogFile
		if [ -e /tmp/pmc_maxRAID_WebServer ] ; then
                        rm -f /tmp/pmc_maxRAID_WebServer
                fi
                echo export maxRAID=$installedPath  >> /tmp/pmc_maxRAID_WebServer
                echo export JRE_HOME=$installedPath"/Web_Server/JRE/jre1.6.0_12/" >> /tmp/pmc_maxRAID_WebServer
                echo export CATALINA_PID=$installedPath"/Web_Server/TOMCAT/bin/PID" >> /tmp/pmc_maxRAID_WebServer
                cat $installedPath/Web_Server/TOMCAT/bin/maxRAID_WebServer >> /tmp/pmc_maxRAID_WebServer
                rm -f $installedPath/Web_Server/TOMCAT/bin/maxRAID_WebServer
		if [ -e /etc/init.d/maxRAID_WebServer ] ; then
			rm -f /etc/init.d/maxRAID_WebServer
		fi
                cp /tmp/pmc_maxRAID_WebServer /etc/init.d/
                mv /etc/init.d/pmc_maxRAID_WebServer /etc/init.d/maxRAID_WebServer
                chmod +x /etc/init.d/maxRAID_WebServer
		chkconfig --add maxRAID_WebServer
		chkconfig --level 23456 maxRAID_WebServer on
        
		if [ "$Linux" == "SUSE" ] ; then       
                        rm -rf /etc/init.d/rc2.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc3.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc4.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc5.d/S01maxRAID_CIMServer
                        rm -rf /etc/init.d/rc6.d/S01maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc2.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc3.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc4.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc5.d/S02maxRAID_CIMServer
                        ln -s /etc/init.d/maxRAID_CIMServer /etc/init.d/rc6.d/S02maxRAID_CIMServer
 
			rm -rf /etc/init.d/rc2.d/S01maxRAID_WebServer
        	        rm -rf /etc/init.d/rc3.d/S01maxRAID_WebServer
                	rm -rf /etc/init.d/rc4.d/S01maxRAID_WebServer
	                rm -rf /etc/init.d/rc5.d/S01maxRAID_WebServer
        	        rm -rf /etc/init.d/rc6.d/S01maxRAID_WebServer
			ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc2.d/S04maxRAID_WebServer
                	ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc3.d/S04maxRAID_WebServer
	                ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc4.d/S04maxRAID_WebServer
        	        ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc5.d/S04maxRAID_WebServer		
			ln -s /etc/init.d/maxRAID_WebServer /etc/init.d/rc6.d/S04maxRAID_WebServer
		fi
		rm -f /tmp/pmc_maxRAID_WebServer
	        
		#Adding firewall entry
		echo Adding firewall exception >> $installLogFile
		if [ "$Linux" == "SUSE" ] ; then
			echo " " >> /etc/PMC-Sierra/maxRAID.conf
			cat /tmp/pmc_custom_ports >> /etc/PMC-Sierra/maxRAID.conf 2> /dev/null
                        rm -rf /tmp/pmc_custom_ports
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
                        if [ "$WebServer_Port" == "" ] ; then
                                WebServer_Port=8443
                        fi
			config_file=/etc/sysconfig/SuSEfirewall2
			tmpfile=/tmp/__firewall_config_$$
			cat $config_file | sed "/^FW_SERVICES_EXT_TCP=/s/\"$/ $WebServer_Port\"/" > $tmpfile
			mv -f $tmpfile $config_file
			rm -rf $tmpfile
			cat $config_file | sed '/^FW_SERVICES_EXT_UDP=/s/\"$/ 427\"/' > $tmpfile
			mv -f $tmpfile $config_file
			rm -rf $tmpfile
		elif [ "$Linux" == "RedHat" ] ; then
			echo " " >> /etc/PMC-Sierra/maxRAID.conf
			cat /tmp/pmc_custom_ports >> /etc/PMC-Sierra/maxRAID.conf 2> /dev/null
                        rm -rf /tmp/pmc_custom_ports
                        WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
			echo "--port=$WebServer_Port:tcp" >> /etc/sysconfig/system-config-securitylevel
                        echo "--port=427:udp" >> /etc/sysconfig/system-config-securitylevel
		fi
		
                #Adding custom port entries to files
		echo Adding custom port entries to corresponding files >> $installLogFile
                httpPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep CIMServer_httpPort | cut -f2 -d "="`
		if [ "$httpPort" == "" ] ; then
			httpPort=5988
		fi
                echo "httpPort=$httpPort" >> $installedPath/CIM_Server/cimserver_planned.conf

                httpsPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep CIMServer_httpsPort | cut -f2 -d "="`
                if [ "$httpsPort" == "" ] ; then
                        httpsPort=5989
                fi
                echo "httpsPort=$httpsPort" >> $installedPath/CIM_Server/cimserver_planned.conf

                sed "s/5988/$httpPort/g" $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml > /tmp/config
                cat /tmp/config > $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml
                rm -rf /tmp/config

                WebServerPort=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
                if [ "$WebServerPort" == "" ] ; then
                        WebServerPort=8443
                fi
                sed "s/8443/$WebServerPort/g" $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml > /tmp/config
		cat /tmp/config > $installedPath/Web_Server/TOMCAT/webapps/maxRAIDManager/config/server.xml
		rm -rf /tmp/config
		sed "s/8443/$WebServerPort/g" $installedPath/Web_Server/TOMCAT/conf/server.xml > /tmp/config
                cat /tmp/config > $installedPath/Web_Server/TOMCAT/conf/server.xml
                rm -rf /tmp/config
                #rm -rf /tmp/pmc_custom_ports
	
		keytool=$installedPath/Web_Server/JRE/jre1.6.0_12/bin/keytool
                HOSTNAME=`hostname`
                IPADDRESS=`hostname -i`
		HOSTIPSTR="CN=localhost, CN=127.0.0.1,"
		
		if [ "$HOSTNAME" != "" ];then
        		HOSTIPSTR="CN=$HOSTNAME, $HOSTIPSTR"
		fi
		if [ "$IPADDRESS" != "" ];then
		        HOSTIPSTR="$HOSTIPSTR CN=$IPADDRESS,"
		fi
		
		$keytool -genkey -alias maxRAIDCert -dname "$HOSTIPSTR OU=Enterprise Storage Division, O=PMC-Sierra\, Inc, L=Santa Clara, S=CA, C=USA" -validity 3650 -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123

                $keytool -selfcert -alias maxRAIDCert -validity 3650 -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123

                $keytool -exportcert -keystore $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks -storepass maxRAID@123 -keypass maxRAID@123 -alias maxRAIDCert -file $installedPath/Web_Server/TOMCAT/conf/maxRAIDManager.cer


		echo Starting AENDaaemon >> $installLogFile
		service maxRAID_Notifier start
		
                echo Starting cimserver >> $installLogFile
                echo Starting cimserver
                service maxRAID_CIMServer start

                echo Starting TOMCAT Web Serverr >> $installLogFile
                echo Starting TOMCAT Web Server
                service maxRAID_WebServer start

        fi
	;;
	*)
	esac

elif [ "$1" == "-uc" ]
then
#Unconfigure individual component
	echo Unconfiguring individual component >> $installLogFile
	case $2 in
	"CLI")
        installedPath=$3"/PMC-Sierra/maxRAID"
        echo Checking if CLI is installed >> $installLogFile
        sh scripts/Verify.sh -c CLI
        retval=$?
        if [ $retval -eq 1 ] ; then
                rm -rf /usr/bin/brcli
        fi
	;;
	"Extended_Manageability")
	installedPath=$3"/PMC-Sierra/maxRAID"
	echo Checking if Extended Manageability components are installed >> $installLogFile
	sh scripts/Verify.sh -c Extended_Manageability
        retval=$?
        if [ $retval -eq 1 ] ; then

		rm -f $installedPath/bin/MailerPlugIn.so
			
		#Deleting firewall entry
		echo Deleting firewall exception >> $installLogFile
		if [ "$Linux" == "SUSE" ] ; then
			WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
                        if [ "$WebServer_Port" == "" ] ; then
                                WebServer_Port=8443
                        fi
			config_file=/etc/sysconfig/SuSEfirewall2
        	        tmpfile=/tmp/__firewall_config_$$
			cat $config_file | sed "/^FW_SERVICES_EXT_TCP=/s/ $WebServer_Port//g" > $tmpfile
			mv -f $tmpfile $config_file		
			rm -rf $tmpfile
			cat $config_file | sed '/^FW_SERVICES_EXT_UDP=/s/ 427//g' > $tmpfile
			mv -f $tmpfile $config_file
        	        rm -rf $tmpfile
		elif [ "$Linux" == "RedHat" ] ; then
       		        WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
			cat /etc/sysconfig/system-config-securitylevel | sed "/^--port=$WebServer_Port:tcp/s/--port=$WebServer_Port:tcp//g" > /tmp/system-config-securitylevel
                        mv /tmp/system-config-securitylevel /etc/sysconfig/system-config-securitylevel
                        rm -rf /tmp/system-config-securitylevel
                        cat /etc/sysconfig/system-config-securitylevel | sed "/^--port=427:udp/s/--port=427:udp//g" > /tmp/system-config-securitylevel
                        mv /tmp/system-config-securitylevel /etc/sysconfig/system-config-securitylevel
                        rm -rf /tmp/system-config-securitylevel

		fi
		
		if [ "`ls /etc/init.d | grep tomcatd`" != "" ];then
                	pid_of_java=`ps -aef | grep maxRAID/Web_Server/TOMCAT | grep -v grep | awk '{print $2}'`
                        kill -9 $pid_of_java
                        rm -rf /etc/init.d/tomcatd
                        rm -rf $installedPath/Web_Server/TOMCAT/webapps/help
                        rm -rf $installedPath//Web_Server/TOMCAT/work/Catalina
		elif [ "`ls /etc/init.d | grep maxRAID_WebServer`" != "" ];then	
	                echo Stopping TOMCAT web server >> $installLogFile
        	        echo Stopping TOMCAT web server...
			service maxRAID_WebServer stop
			chkconfig --del maxRAID_WebServer
			rm -f /etc/init.d/maxRAID_WebServer
		fi
                rm -f $installedPath/Web_Server/TOMCAT/bin/PID
                rm -f $installedPath/Web_Server/TOMCAT/logs/*
                rm -f $installedPath/Web_Server/*.log
                rm -rf $installedPath/Web_Server/TOMCAT/work/*
                rm -rf $installedPath/Web_Server/TOMCAT/webapps/help

		
		if [ "`ls /etc/init.d | grep cimserverd`" != "" ];then
                	service cimserverd stop
                        chkconfig --del cimserverd
                        rm -rf /etc/init.d/cimserverd
		elif [ "`ls /etc/init.d | grep maxRAID_CIMServer`" != "" ];then
	                echo Stopping cimserver >> $installLogFile
        	        echo -n Stopping cimserver...
			service maxRAID_CIMServer stop
			chkconfig --del maxRAID_CIMServer
			rm -f /etc/init.d/maxRAID_CIMServer
		fi
		rm -f $installedPath/CIM_Server/lib/*.so
		rm -rf /etc/pam.d/wbem
		
		if [ "`ls /etc/init.d | grep aend`" != "" ];then
                	service aend stop
                        chkconfig --del aend
                        rm -rf /etc/init.d/aend
		elif [ "`ls /etc/init.d | grep maxRAID_Notifier`" != "" ];then
			echo Stopping AenDaemon >> $installLogFile
                	service maxRAID_Notifier stop
			chkconfig --del maxRAID_Notifier
                	rm -f /etc/init.d/maxRAID_Notifier
        	fi
	fi
	;;
	*)
	esac
fi
