#!/bin/bash

installLogFile=/var/log/PMC-Sierra_maxRAID.log

echo "The product is already installed. Please select any option.. "
echo The product is already installed >> $installLogFile
choice=""
while [ "$choice" != "1" ] && [ "$choice" != "2" ] && [ "$choice" != "3" ] && [ "$choice" != "0" ]
do
	echo 1. Modify
	echo 2. Repair
	echo 3. Remove
	echo -n [ Press 0 to quit ] : 
	read choice

	if [ "$choice" != "1" ] && [ "$choice" != "2" ] && [ "$choice" != "3" ] && [ "$choice" != "0" ] ;
	then
		echo "Wrong choice.."
	fi
done

if [ "$choice" == "0" ] ;
then
	echo Exiting Installation
	echo Exiting Installation >> $installLogFile
	rm -rf /tmp/pmc_installed
	exit
fi

case $choice in
	1)
	  echo Checking if the installer version >> $installLogFile
	  sh scripts/Verify.sh -v
	  status=$?
	  if [ $status -eq 0 ] ; then
		finish=0
		newStr=""
		oldStr=""
		if [ -e /etc/PMC-Sierra/maxRAID.conf ] ; then
		    for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
		    do
		        if [ "$oldStr" == "[InstalledComponent]" ] ; then
			    components=$newStr
			    break
			else
			    oldStr=$newStr
			fi
		    done
		    i=1
		    cmpnt=""
		    preCmpnt=""
		    while [ $finish -eq 0 ]
		    do
		        cmpnt=`echo $components | cut -d: -f$i`
			if [ "$preCmpnt" == "$cmpnt" ] ; then
			    break
			fi
			preCmpnt=$cmpnt
			if [ "$cmpnt" == "" ] ; then
			    finish=1
			    break
			fi
			comp=`rpm -qa | grep $cmpnt`
			if [ "$comp" != "" ] ; then
				echo $comp is installed...
				echo $comp is installed... >> $installLogFile
			fi
			i=`expr $i + 1`
		    done
		fi

		_newStr=""
		_oldStr=""
		for _newStr in `cat scripts/maxRAID.conf`
		do
		    if [ "$_oldStr" == "[AvailableComponents]" ] ; then
			availableCmpnts=$_newStr
			break
		    else
			_oldStr=$_newStr
		    fi
		done
		i=1
		_finish=0
		count=0
		_preCmpnt=""
		notPresent=""
		while [ $_finish -eq 0 ]
		do
		    _cmpnt=`echo $availableCmpnts | cut -d: -f$i`
		    if [ "$_preCmpnt" == "$_cmpnt" ] ; then
			break
		    fi
		    _preCmpnt=$_cmpnt
		    if [ "$_cmpnt" == "" ] ; then
			_finish=1
			break
		    fi
		    if [ `echo $components | grep $_cmpnt | wc -l` -eq 0 ] ; then
			    count=`expr $count + 1`
			    case $_cmpnt in
				"CLI")
					orgName="CLI Feature"
				;;
				"Extended_Manageability")
					orgName="Extended Management Software Feature"
				;;
			    esac
			    if [ "$notPresent" == "" ] ; then
				notPresent=$_cmpnt
				display=$orgName
			    else
				notPresent=$notPresent:$_cmpnt
				display=$display:"$orgName"
			    fi
		    fi
		    i=`expr $i + 1`
		done
		echo ""
		if [ $count -gt 0 ] ; then
		    #Retrieve install path
		    echo Retrieving installed patha >> $installLogFile
	            _newStr=""
                    _oldStr=""
                    for _newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
                    do
                        if [ "$_oldStr" == "[InstalledPath]" ] ; then
                            installPath=$_newStr
                            break
                        else
                            _oldStr=$_newStr
                        fi
                    done
		    i=1
		    echo "Please  select from the options...(use space between two choices)"
		    while [ $i -le $count ]
		    do
			echo $i. `echo $display | cut -d: -f$i`
			i=`expr $i + 1`
		    done
		    echo -n [Press 0 to quit] : 
		    read customChoice

		    if [ "$customChoice" == "0" ] ; then
			echo Exiting Installation
			echo Exiting Installation >> $installLogFile
			rm -rf /tmp/pmc_installed
			exit
		    fi

		    _status=1
		    i=1
		    temp=`echo $customChoice | cut -d' ' -f$i`
		    oldTemp=$temp
		    while [ "$temp" != "" ]
		    do
			it=0
			isInputValid=0
			while [ $it -le $count ]
			do
				if [ "$it" == "$temp" ] ; then
					isInputValid=1
				fi
				it=`expr $it + 1`
			done
			if [ $isInputValid -eq 0 ] ; then
				_status=0
				break
			fi
		        i=`expr $i + 1`
		        temp=`echo $customChoice | cut -d' ' -f$i`
		        if [ "$oldTemp" == "$temp" ] ; then
		                break
		        fi
		    done
		    if [ $_status -eq 0 ] ; then
		        echo One or more input options are wrong. Exiting installation.
			echo One or more input options are wrong...Exiting installation >> $installLogFile
			rm -rf /tmp/pmc_installed
			exit
		    fi

		    i=1
		    _components=""
		    choice=`echo $customChoice | cut -d' ' -f$i`
		    oldChoice=$choice
		    while [ "$choice" != "" ]
		    do
			compnt=`echo $notPresent | cut -d: -f$choice`
			case $compnt in
				"CLI")
				sh scripts/RunRPM.sh -i CLI $installPath
				status=$?
				if [ $status -eq 0 ] ; then
					sh scripts/Configure.sh -cc CLI $installPath
					if [ $status -ne 0 ] ; then
						echo Configuration failed for CLI component
						echo Configuration failed for CLI component...Rolling back changes >> $installLogFile
						sh scripts/Rollback.sh $installPath
						exit
					fi
				fi
				if [ "$_components" == "" ] ; then
					_components="CLI"
				else
					_components=$_components":CLI"
				fi
				;;
				"Extended_Manageability")
		                validate_port()
        			{
				        echo validating custom ports >> $installLogFile
					if [ "`netstat -an | grep -w $2`" == "" -a $2 -ne $3 -a $2 -ne $4 ];then
				                PORT_NUMBER=$2
        				else
				                echo Selected port is not free...giving a free port
				                for ((  i = 49152  ;  i <= 65535;  i++  ))
				                do
				                        if [ "`netstat -an | grep -w $i`" == "" ];then
                                				if [ $i -ne $2 -a $i -ne $3 -a $i -ne $4 ];then
				                                        PORT_NUMBER=$i
                                				        break
                                				fi
				                        fi
				                done
				        fi
        			}

			        CIMServer_httpPort=5988
			        CIMServer_httpsPort=5989
			        WebServer_Port=8443
				
				echo Setting ports >> $installLogFile
			        echo Default CIMServer_httpPort is 5988
			        echo Do you want to change this port\?
			        echo -n "Press \"Y\" to change and \"N\" to continue with the default port:"
			        read port_change
			        if [ "$port_change" == "Y" ] || [ "$port_change" == "y" ];then
			                PORT="CIMServer_httpPort"
			                echo Enter port number
			                read PORT_NUMBER
			        else
			                PORT="CIMServer_httpPort"
			                PORT_NUMBER=$CIMServer_httpPort
        			fi
			        validate_port "$PORT" "$PORT_NUMBER" 0 0
			        CIMServer_httpPort=$PORT_NUMBER

			        echo Default CIMServer_httpsPort is 5989
			        echo Do you want to change this port\?
			        echo -n "Press \"Y\" to change and \"N\" to continue with the default port:"
			        read port_change
			        if [ "$port_change" == "Y" ] || [ "$port_change" == "y" ];then
			                PORT="CIMServer_httpsPort"
	                		echo Enter port number
			                read PORT_NUMBER
			        else
			                PORT="CIMServer_httpsPort"
			                PORT_NUMBER=$CIMServer_httpsPort
        			fi
			        validate_port "$PORT" "$PORT_NUMBER" $CIMServer_httpPort 0
			        CIMServer_httpsPort=$PORT_NUMBER

			        echo Default WebServer_Port is 8443
			        echo Do you want to change this port\?
			        echo -n "Press \"Y\" to change and \"N\" to continue with the default port:"
			        read port_change
			        if [ "$port_change" == "Y" ] || [ "$port_change" == "y" ];then
			                PORT="WebServer_Port"
			                echo Enter port number
			                read PORT_NUMBER
			        else
			                PORT="WebServer_Port"
			                PORT_NUMBER=$WebServer_Port
        			fi
			        validate_port "$PORT" "$PORT_NUMBER" $CIMServer_httpPort $CIMServer_httpsPort
			        WebServer_Port=$PORT_NUMBER

			        echo Selected ports are
			        echo [CustomPorts] > /tmp/pmc_custom_ports
			        echo CIMServer_httpPort=$CIMServer_httpPort | tee -a /tmp/pmc_custom_ports
			        echo CIMServer_httpsPort=$CIMServer_httpsPort | tee -a /tmp/pmc_custom_ports
			        echo WebServer_Port=$WebServer_Port | tee -a /tmp/pmc_custom_ports

				sh scripts/RunRPM.sh -i Extended_Manageability $installPath
		                status=$?
				if [ $status -eq 0 ] ; then
					sh scripts/Configure.sh -cc Extended_Manageability $installPath
					status=$?
					if [ $status -ne 0 ] ; then
						echo Configuration failed for Extended Manageability component
						echo Configuration failed for Extended Manageability component...Rolling back changes >> $installLogFile
						sh scripts/Rollback.sh $installPath
						exit
					fi
				fi
		                if [ "$_components" == "" ] ; then
			                _components="Extended_Manageability"
		                else
			                _components=$_components":Extended_Manageability"
		                fi
				;;
		    	esac

			if [ $status -ne 0 ] ; then
				echo Installation failed...
				echo Installation failed...Rolling back changes >> $installLogFile
				sh scripts/Rollback.sh $installPath
				rm -rf /tmp/pmc_installed
				exit
			fi

			i=`expr $i + 1`
			choice=`echo $customChoice | cut -d' ' -f$i`
			if [ "$oldChoice" == "$choice" ] ; then
				break
			fi
			oldChoice=$choice
		    done

		    _found=0
		    _newStr=""
		    _oldStr=""
		    for _newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
		    do
			if [ "$_oldStr" == "[InstalledComponent]" ] ; then
			    _found=1
			    break
			else
			    _oldStr=$_newStr
			fi
		    done
		    if [ $_found -eq 1 ] ; then
			echo Writing the installed components in /etc/PMC-Sierra/maxRAID.conf >> $installLogFile
			_components=$_newStr:$_components
			sed 's/'$_newStr'/'$_components'/' </etc/PMC-Sierra/maxRAID.conf >/etc/PMC-Sierra/maxRAID.conf.new
			rm -f /etc/PMC-Sierra/maxRAID.conf
			mv /etc/PMC-Sierra/maxRAID.conf.new /etc/PMC-Sierra/maxRAID.conf
		    else
			echo " " >> /etc/PMC-Sierra/maxRAID.conf
			echo [InstalledComponent] >> /etc/PMC-Sierra/maxRAID.conf
			echo $_components >> /etc/PMC-Sierra/maxRAID.conf
		    fi
		    if [ $status -eq 0 ] ; then 
		    	echo Successfully modified the product
		        echo Successfully modified the product >> $installLogFile
		    else 
			echo Failed to modify the product.
			echo Failed to modify the product >> $installLogFile
		    fi
		else
		        echo All the features are installed >> $installLogFile
			echo All the features are installed.
		fi
	  else
	      echo "Either the configuration file doesn't exist or the installer version is different than that of Installed"
	      echo "Either the configuration file doesn't exist or the installer version is different than that of Installed" >> $installLogFile
	  fi
	;;
	2)
	  echo Checking the installer version >> $installLogFile
	  sh scripts/Verify.sh -v
	  status=$?
	  if [ $status -eq 0 ] ; then

		echo Re-installing the product
		echo Re-installing the product >> $installLogFile
		if [ -e /etc/PMC-Sierra/maxRAID.conf ] ; then

			#Taking a back-up of the configuration file for reference
			cp /etc/PMC-Sierra/maxRAID.conf /tmp/


			#Retrieving the list of installed components
			echo Retrieving the list of installed components >> $installLogFile
			newStr=""
			oldStr=""
			compList=""
			for newStr in `cat /tmp/maxRAID.conf`
			do
				if [ "$oldStr" == "[InstalledComponent]" ] ; then
					compList=$newStr
					break
				else
					oldStr=$newStr
				fi
			done


                        #Checking whether installed component(s) is(are) present in the media
			i=1
                        oldComp=""
                        comp=`echo $compList | cut -d: -f$i`
                        while [ "$comp" != "" ]
                        do
                                if [ "$comp" == "$oldComp" ] ; then
                                        break
                                fi
				component_rpm=`rpm -qa | grep $comp`
				if [ "`uname -p`" == "x86_64" ] ; then
        				machine=.x86_64
        				component_rpm=$component_rpm$machine.rpm
				fi
				status=`ls rpms/ | grep -x $component_rpm | wc -l`
				if [ $status -eq 0 ] ; then
					echo $component_rpm is not present in the disk.
					echo Exiting the installation.
					echo $component_rpm is not present in the disk....Exiting installation >> $installLogFile
					rm -f /tmp/maxRAID.conf
					rm -rf /tmp/pmc_installed
					exit
				fi
                                i=`expr $i + 1`
                                oldComp=$comp
                                comp=`echo $compList | cut -d: -f$i`
                        done


			#Retrieving the installed path
                        echo Retrieving installed path >> $installLogFile
			_newStr=""
                        _oldStr=""
			installedPath=""
                        for _newStr in `cat /tmp/maxRAID.conf`
                        do
                                if [ "$_oldStr" == "[InstalledPath]" ] ; then
                                        installedPath=$_newStr
                                        break
                                else
                                        _oldStr=$_newStr
                                fi
                        done


                        #Un-configuring the product
                        echo Un-configuring the product >> $installLogFile
			sh scripts/Configure.sh -u

                        #Un-installing the product
			echo Un-installing the product >> $installLogFile
                        sh scripts/Remove.sh


			#Re-installing previously installed component(s)
			i=1
			oldComp=""
			comp=`echo $compList | cut -d: -f$i`
			while [ "$comp" != "" ]
			do
				if [ "$comp" == "$oldComp" ] ; then
					break
				fi
				sh scripts/RunRPM.sh -i $comp $installedPath
				if [ $? -ne 0 ] ; then
					echo Installation failed.
					echo Installation failed...Rolling back the changes >> $installLogFile
					sh scripts/Rollback.sh $installedPath
					rm -rf /tmp/pmc_installed
					rm -f /tmp/maxRAID.conf
					exit
				fi
				i=`expr $i + 1`
				oldComp=$comp
				comp=`echo $compList | cut -d: -f$i`
			done

			#Configuring the product
			echo Creating /etc/PMC-Sierra directory during repair >> $installLogFile
			mkdir /etc/PMC-Sierra
			echo "#maxRAID configuration" > /etc/PMC-Sierra/maxRAID.conf
			echo "" >> /etc/PMC-Sierra/maxRAID.conf

                        #Retrieving the version of the installed package
                        echo Retrieving the version of the installed package >> $installLogFile
			newStr=""
                        oldStr=""
                        version=""
                        for newStr in `cat /tmp/maxRAID.conf`
                        do
                                if [ "$oldStr" == "[Version]" ] ; then
                                        version=$newStr
                                        break
                                else
                                        oldStr=$newStr
                                fi
                        done

			echo "[Version]" >> /etc/PMC-Sierra/maxRAID.conf
			echo $version >> /etc/PMC-Sierra/maxRAID.conf
			echo "" >> /etc/PMC-Sierra/maxRAID.conf

			echo "[InstalledPath]" >> /etc/PMC-Sierra/maxRAID.conf
			echo $installedPath >> /etc/PMC-Sierra/maxRAID.conf
			echo "" >> /etc/PMC-Sierra/maxRAID.conf

			#Storing Custom port configuration in a temp file for later use by Configure.sh
			echo Storing Custom port configuration in a temp file for later use by Configure.sh >> $installLogFile
			cat /tmp/maxRAID.conf | grep CustomPorts > /tmp/pmc_custom_ports
			cat /tmp/maxRAID.conf | grep CIMServer_httpPort >> /tmp/pmc_custom_ports
			cat /tmp/maxRAID.conf | grep CIMServer_httpsPort >> /tmp/pmc_custom_ports
			cat /tmp/maxRAID.conf | grep WebServer_Port >> /tmp/pmc_custom_ports	

                        it=1
                        oldComp=""
                        comp=`echo $compList | cut -d: -f$it`
                        while [ "$comp" != "" ]
                        do
                                if [ "$comp" == "$oldComp" ] ; then
                                        break
                                fi
                                sh scripts/Configure.sh -cc $comp $installedPath
                                if [ $? -ne 0 ] ; then
                                        echo Installation failed.
					echo Installation failed...Rolling back changes >> $installLogFile
                                        sh scripts/Rollback.sh $installedPath
                                        rm -f /tmp/maxRAID.conf
                                        rm -rf /tmp/pmc_installed
					exit
                                fi
                                it=`expr $it + 1`
                                oldComp=$comp
                                comp=`echo $compList | cut -d: -f$it`
                        done

                        echo Writing the installed component in /etc/PMC-Sierra/maxRAID.conf >> $installLogFile
                        echo "" >> /etc/PMC-Sierra/maxRAID.conf
			echo [InstalledComponent] >> /etc/PMC-Sierra/maxRAID.conf
                        echo $compList >> /etc/PMC-Sierra/maxRAID.conf

			rm -f /tmp/maxRAID.conf

			echo Product is re-installed successfully.
			echo Product is re-installed successfully >> $installLogFile

		else
			echo Configuration file is not present in /etc/PMC-Sierra. Cannot repair.
			echo  Configuration file is not present in /etc/PMC-Sierra...Cannot repair >> $installLogFile
		fi
	  else
		echo "Product version is not same."
		echo Product version is not same >> $installLogFile
	  fi
	;;
	3)
	  sh scripts/Configure.sh -u
	  if [ $? -eq 0 ] ; then sh scripts/Remove.sh
	  else 
		echo Un-installation failed.
		echo Un-installation failed >> $installLogFile
	  fi
	;;
esac
echo ""
