#!/bin/bash

installLogFile=/var/log/PMC-Sierra_maxRAID.log

echo Retrieving the list of installed components >> $installLogFile
finish=0
i=1
newStr=""
oldStr=""
for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
do
        if [ "$oldStr" == "[InstalledComponent]" ] ; then
		components=$newStr
		break
        else
                oldStr=$newStr
        fi
done


echo Retrieving the list of installed path >> $installLogFile
_newStr=""
_oldStr=""
installedPath=""
for _newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
do
        if [ "$_oldStr" == "[InstalledPath]" ] ; then
                installedPath=$_newStr
                break
        else
                _oldStr=$_newStr
        fi
done

installedPath=$installedPath"/PMC-Sierra/maxRAID"

rm -rf $installedPath/CIM_Server/repository/*
rm -rf $installedPath/Web_Server/JRE/jre1.6.0_12/.systemPrefs
rm -rf $installedPath/Web_Server/TOMCAT/conf/maxRAIDManager.cer  
rm -rf $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks
preCmpnt=""
while [ $finish -eq 0 ]
do
	cmpnt=`echo $components | cut -d: -f$i`
	if [ "$preCmpnt" == "$cmpnt" ] ; then
		break
	fi
	preCmpnt=$cmpnt
	if [ "$cmpnt" == "" ] ; then
		finish=1
		break
	fi
	echo Uninstalling `rpm -qa | grep $cmpnt` >> $installLogFile
	echo -n Uninstalling `rpm -qa | grep $cmpnt`...
	rpm -e $cmpnt
	status=$?
	if [ $status -eq 0 ] ; then echo Done.
	else 
		echo Failed.
		echo Uninstallation failed >> $installLogFile
	fi
	i=`expr $i + 1`
done

rm -rf /etc/PMC-Sierra
echo ""
