#!/bin/bash

installLogFile=/var/log/PMC-Sierra_maxRAID.log

if [ "$1" != "" ] ; then

installPath=$1"/PMC-Sierra/maxRAID"
	echo Rolling back the changes >> $installLogFile
	echo Rolling back the changes....

	echo Unconfiguring....
	echo Unconfiguring >> $installLogFile

        if [ -e $installPath/log/*.log ] ; then
                echo Deleting log files >> $installLogFile
                echo Deleting log files....
                rm -rf $installPath/log/*.log
        fi

	if [ `rpm -qa | grep Extended_Manageability | wc -l` -gt 0 ] ; then
		if [ `pidof java` ] ; then
			service maxRAID_WebServer stop
	                chkconfig --del maxRAID_WebServer
	                rm -f /etc/init.d/maxRAID_WebServer
	                rm -f $installedPath/Web_Server/TOMCAT/bin/PID
	                rm -f $installedPath/Web_Server/TOMCAT/logs/*
	                rm -f $installedPath/Web_Server/*.log
		fi

		if [ `pidof cimserver` ] ; then
	                service maxRAID_CIMServer stop
	                chkconfig --del maxRAID_CIMServer
	                rm -f /etc/init.d/maxRAID_CIMServer
	                rm -rf /etc/pam.d/wbem
	                rm -f $installedPath/CIM_Server/lib/*.so
		fi

		if [ `pidof AenDaemon` ] ; then
	                service maxRAID_Notifier stop
	                chkconfig --del maxRAID_Notifier
	                rm -f /etc/init.d/maxRAID_Notifier
		fi
	fi

	if [ `grep "maxRAID" /etc/profile | wc -l` -gt 0 ] ; then
	        sed '/maxRAID/d' </etc/profile >/etc/newprofile
	        rm -f /etc/profile
	        mv /etc/newprofile /etc/profile
	fi

        if [ -e /usr/bin/brcli ] ; then
                rm -f /usr/bin/brcli
        fi

        echo Resetting environment...
        unset maxRAID

        if [ -e /usr/bin/maxRAID_Notifier ] ; then
                echo Removing maxRAID_Notifier from /usr/bin ...
                rm -rf /usr/bin/maxRAID_Notifier
        fi
	if [ -d /etc/PMC-Sierra ] ; then
		echo Deleting /etc/PMC-Sierra
		rm -rf /etc/PMC-Sierra
	fi

	finish=0
	i=1
	newStr=""
	oldStr=""
	for newStr in `cat scripts/maxRAID.conf`
	do
	        if [ "$oldStr" == "[AvailableComponents]" ] ; then
	                components=$newStr
	                break
	        else
	                oldStr=$newStr
	        fi
	done

	preCmpnt=""
	while [ $finish -eq 0 ]
	do
	        cmpnt=`echo $components | cut -d: -f$i`
	        if [ "$preCmpnt" == "$cmpnt" ] ; then
	                break
	        fi
	        preCmpnt=$cmpnt
	        if [ "$cmpnt" == "" ] ; then
	                finish=1
	                break
	        fi
		if [ `rpm -qa | grep $cmpnt | wc -l` -gt 0 ] ; then
		        echo -n Uninstalling $cmpnt...
		        rpm -e $cmpnt
		        status=$?
		        if [ $status -eq 0 ] ; then echo Done.
		        else echo Failed.
		        fi
		fi
	        i=`expr $i + 1`
	done
echo Done
fi
