#!/bin/bash

installLogFile=/var/log/PMC-Sierra_maxRAID.log

isPresent=0

#Arg1: file name
#Arg2: major/minor/build
getVersion() {

	newStr=""
	oldStr=""
	for newStr in `cat $1`
	do
		if [ "$oldStr" == "[Version]" ] ; then
			value=`echo $newStr | cut -d: -f1 | cut -d. -f$2`
			retval=`expr $value` 
			return $retval
		else
			oldStr=$newStr
		fi
	done
	return 0
}

if [ "$1" != "" ] ;
then

#Check whether the product is installed
	echo Check whether the product is installed >> $installLogFile
	case $1 in
	    "-p")
		if [ -e /etc/PMC-Sierra/maxRAID.conf ] ; then
			getVersion /etc/PMC-Sierra/maxRAID.conf 1
			_major=$?
			if [ $_major -gt 0 ] ; then
				exit $_major
			else
				exit 0
			fi
		else
		    exit 0
		fi
		  ;;

#Verify whether the installer version is greater than the already installed one
	    "-v")
		if [ -e /etc/PMC-Sierra/maxRAID.conf ] ; then
			getVersion /etc/PMC-Sierra/maxRAID.conf 1
			_major=$?
			getVersion /etc/PMC-Sierra/maxRAID.conf 2
			_minor=$?
			getVersion /etc/PMC-Sierra/maxRAID.conf 3
			_build=$?
			getVersion scripts/maxRAID.conf 1
			major=$?
			getVersion scripts/maxRAID.conf 2
			minor=$?
			getVersion scripts/maxRAID.conf 3
			build=$?
			if [ $major -gt $_major ] ; then
				exit 1
			else
				if [ $major -eq $_major ] && [ $minor -gt $_minor  ] ; then
						exit 1
				else
					if [ $major -eq $_major ] && [ $minor -eq $_minor  ] && [ $build -gt $_build ] ; then
						exit 1
					elif [ $major -eq $_major ] && [ $minor -eq $_minor  ] && [ $build -ge $_build ]
					then
						exit 0
					else
						exit 255
					fi
				fi
			fi
		else
			exit 255
		fi
		;;
#Check whether the specified product is installed using the keywords
	 "-c")
		if [ "$2" != "" ] ;
		then
		        isPresent=`rpm -qa | grep $2 | wc -l`
			exit $isPresent
		fi
		;;
	esac
fi


