#!/bin/bash

if [ -f /etc/redhat-release ] ; then
        v1=`cat /etc/redhat-release | cut -f1 -d " "`
        v2=`cat /etc/redhat-release | cut -f2 -d " "`
        Linux=$v1$v2
else
        if [ -f /etc/SuSE-release ] ; then
                Linux=`cat /etc/SuSE-release | grep SUSE | cut -f1 -d " "`
        fi
fi

#Check if any other copy of the installer is running
#if [ -e /tmp/pmc_installed ] ; then
#        echo Another installer is already running
#        read -p "Press any key to exit..." anykey
#        exit
#fi

#Creating file to check whether other instance of installation script is running
echo "maxRAID_manager" > /tmp/pmc_installed

if [ ! -e /etc/PMC-Sierra/maxRAID.conf ] ; then
	echo Configuration file /etc/PMC-Sierra/maxRAID.conf is missing.
	echo Cannot uninstall the product
	#rm -rf /tmp/pmc_installed
	exit
fi

newStr=""
oldStr=""
installedCmpnt=""
for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
do
        if [ "$oldStr" == "[InstalledComponent]" ] ; then
                installedCmpnt=$newStr
                break
        else
                oldStr=$newStr
        fi
done

newStr=""
oldStr=""
installedPath=""
for newStr in `cat /etc/PMC-Sierra/maxRAID.conf`
do
        if [ "$oldStr" == "[InstalledPath]" ] ; then
                installedPath=$newStr
                break
        else
                oldStr=$newStr
        fi
done

installedPath=$installedPath"/PMC-Sierra/maxRAID"

insLog=""
echo -n "Would you like to preserve the configuration files: Y(es) / N(o):"
read insLog
if [ "$insLog" == "Y" ] || [ "$insLog" == "y" ] ; then
        if [ -e $installedPath/conf/PmcConfAenDaemon.txt ] ; then
                mv -f $installedPath/conf/PmcConfAenDaemon.txt $installedPath/conf/PmcConfAenDaemon.txt.bak
        fi
        if [ -e $installedPath/conf/PlugInConfig.txt ] ; then
                mv -f $installedPath/conf/PlugInConfig.txt $installedPath/conf/PlugInConfig.txt.bak
        fi
        if [ -e $installedPath/conf/PmcConfBrcli.txt ] ; then
                mv -f $installedPath/conf/PmcConfBrcli.txt $installedPath/conf/PmcConfBrcli.txt.bak
        fi
        if [ -e $installedPath/conf/PmcConfSMIS.txt ] ; then
                mv -f $installedPath/conf/PmcConfSMIS.txt $installedPath/conf/PmcConfSMIS.txt.bak
        fi
	if [ -e $installedPath/conf/PmcConfGUI.properties ] ; then
                mv -f $installedPath/conf/PmcConfGUI.properties $installedPath/conf/PmcConfGUI.properties.bak
        fi

fi
insLog=""
echo -n "Would you like to preserve the components log files: Y(es) / N(o):"
read insLog
if [ "$insLog" != "Y" ] && [ "$insLog" != "y" ] ; then
        echo Deleting log files...
        rm -rf $installedPath/log/*.log
fi

#Unconfigure
echo Unconfiguring the product...
i=1
oldComp=""
comp=`echo $installedCmpnt | cut -d: -f$i`
while [ "$comp" != "" ]
do
        if [ "$comp" == "$oldComp" ] ; then
                break
        fi
	case $comp in
	"CLI")
	if [ -e	/usr/bin/brcli ] ; then
		rm -rf /usr/bin/brcli
	fi
	;;
	"Extended_Manageability")

	 #Deleting firewall settings
	if [ "$Linux" == "SUSE" ] ; then
	  	WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`	
		config_file=/etc/sysconfig/SuSEfirewall2
                tmpfile=/tmp/__firewall_config_$$
                cat $config_file | sed "/^FW_SERVICES_EXT_TCP=/s/ $WebServer_Port//g" > $tmpfile
                mv -f $tmpfile $config_file
                rm -rf $tmpfile
                cat $config_file | sed '/^FW_SERVICES_EXT_UDP=/s/ 427//g' > $tmpfile
                mv -f $tmpfile $config_file
                rm -rf $tmpfile
        elif [ "$Linux" == "RedHat" ] ; then
                WebServer_Port=`cat /etc/PMC-Sierra/maxRAID.conf | grep WebServer_Port | cut -f2 -d "="`
		cat /etc/sysconfig/system-config-securitylevel | sed "/^--port=$WebServer_Port:tcp/s/--port=$WebServer_Port:tcp//g"> system-config-securitylevel
                mv system-config-securitylevel /etc/sysconfig/system-config-securitylevel
                rm -rf system-config-securitylevel
                cat /etc/sysconfig/system-config-securitylevel | sed '/^--port=427:udp/s/--port=427:udp//g'> system-config-securitylevel
                mv system-config-securitylevel /etc/sysconfig/system-config-securitylevel
                rm -rf system-config-securitylevel
        fi
	

	rm -f $installedPath/bin/MailerPlugIn.so
        echo Stopping TOMCAT web server...
	service maxRAID_WebServer stop
	chkconfig --del maxRAID_WebServer
	rm -f /etc/init.d/maxRAID_WebServer
        rm -rf $installedPath/Web_Server/TOMCAT/bin/PID
        rm -rf $installedPath/Web_Server/TOMCAT/logs/*
	rm -rf $installedPath/Web_Server/TOMCAT/work/*
        rm -rf $installedPath/Web_Server/*.log
	rm -rf $installedPath/Web_Server/JRE/jre1.6.0_12/.systemPrefs
	rm -rf $installedPath/Web_Server/TOMCAT/webapps/help
	rm -rf $installedPath/Web_Server/TOMCAT/work/Catalina
	rm -rf $installedPath/Web_Server/TOMCAT/conf/maxRAIDManager.cer  
	rm -rf $installedPath/Web_Server/TOMCAT/conf/maxRAIDStore.jks	

	echo -n Stopping cimserver...
	service maxRAID_CIMServer stop
	chkconfig --del maxRAID_CIMServer
	rm -f /etc/init.d/maxRAID_CIMServer
	rm -rf $installedPath/CIM_Server/lib/*.so
	rm -rf $installedPath/CIM_Server/*so.1
	rm -rf $installedPath/CIM_Server/*so
	rm -rf $installedPath/CIM_Server
	rm -rf $installedPath/CIM_Server/repository/*
	rm -rf /etc/pam.d/wbem
	
	service maxRAID_Notifier stop
	chkconfig --del maxRAID_Notifier
	rm -f /etc/init.d/maxRAID_Notifier

	;;
	*)
	esac

        i=`expr $i + 1`
        oldComp=$comp
        comp=`echo $installedCmpnt | cut -d: -f$i`
done

echo Removing maxRAID environment variable from /etc/profile...
sed '/maxRAID/d' </etc/profile >/etc/newprofile
rm -rf /etc/profile
mv /etc/newprofile /etc/profile

echo -n Resetting environment...
unset maxRAID

#Uninstall
echo Uninstallting the product

i=1
preComp=""
cmpnt=`echo $installedCmpnt | cut -d: -f$i`
while [ "$cmpnt" != "" ]
do
        if [ "$cmpnt" == "$preComp" ] ; then
                break
        fi
        echo -n Uninstalling `rpm -qa | grep $cmpnt`...
        rpm -e $cmpnt
        status=$?
        if [ $status -eq 0 ] ; then echo Done.
        else echo Failed.
        fi
        i=`expr $i + 1`
        preComp=$cmpnt
        cmpnt=`echo $installedCmpnt | cut -d: -f$i`
done

rm -rf /etc/PMC-Sierra
rm -rf /tmp/pmc_installed
